config/routes.rb
Rails.application.routes.draw do
  resources :actor_histories
  resources :movie_watchlists
  resources :actor_fanlists
  resources :actor_lists
  resources :movie_histories
  resources :ratings
  resources :movie_lists
  resources :seasons
  resources :age_ratings
  resources :cast_members
  resources :actors
  resources :movie_tag_counts
  resources :movie_tags
  resources :countries
  resources :genres
  devise_for :users
  resources :movies
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/rating.rb
class Rating < ApplicationRecord
  belongs_to :user
  belongs_to :movie

  validates_length_of :title, maximum: 100, allow_blank: true
  validates :rating, presence: true
  validates :movie_id, presence: true
  validates_uniqueness_of :movie_id, scope: [:user_id]
  validates :user_id, presence: true
end

app/controllers/ratings_controller.rb
class RatingsController < ApplicationController
  before_action :set_rating, only: [:show, :edit, :update, :destroy]

  # GET /ratings
  # GET /ratings.json
  def index
    @ratings = Rating.all
  end

  # GET /ratings/1
  # GET /ratings/1.json
  def show
  end

  # GET /ratings/new
  def new
    @rating = Rating.new
  end

  # GET /ratings/1/edit
  def edit
  end

  # POST /ratings
  # POST /ratings.json
  def create
    @rating = Rating.new(rating_params)

    respond_to do |format|
      if @rating.save
        format.html { redirect_to @rating, notice: 'Rating was successfully created.' }
        format.json { render :show, status: :created, location: @rating }
      else
        format.html { render :new }
        format.json { render json: @rating.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /ratings/1
  # PATCH/PUT /ratings/1.json
  def update
    respond_to do |format|
      if @rating.update(rating_params)
        format.html { redirect_to @rating, notice: 'Rating was successfully updated.' }
        format.json { render :show, status: :ok, location: @rating }
      else
        format.html { render :edit }
        format.json { render json: @rating.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /ratings/1
  # DELETE /ratings/1.json
  def destroy
    @rating.destroy
    respond_to do |format|
      format.html { redirect_to ratings_url, notice: 'Rating was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_rating
      @rating = Rating.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def rating_params
      params.require(:rating).permit(:title, :review, :rating, :user_id, :movie_id)
    end
end

app/helpers/ratings_helper.rb
module RatingsHelper
end

app/views/ratings/_form.html.erb
<%= form_for(rating) do |f| %>
  <% if rating.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(rating.errors.count, "error") %> prohibited this rating from being saved:</h2>

      <ul>
      <% rating.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :title %>
    <%= f.text_field :title %>
  </div>

  <div class="field">
    <%= f.label :review %>
    <%= f.text_area :review %>
  </div>

  <div class="field">
    <%= f.label :rating %>
    <%= f.text_field :rating %>
  </div>

  <div class="field">
    <%= f.label :user_id %>
    <%= f.text_field :user_id %>
  </div>

  <div class="field">
    <%= f.label :movie_id %>
    <%= f.text_field :movie_id %>
  </div>

  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/ratings/edit.html.erb
<h1>Editing Rating</h1>

<%= render 'form', rating: @rating %>

<%= link_to 'Show', @rating %> |
<%= link_to 'Back', ratings_path %>

app/views/ratings/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Ratings</h1>

<table>
  <thead>
    <tr>
      <th>Title</th>
      <th>Review</th>
      <th>Rating</th>
      <th>User</th>
      <th>Movie</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @ratings.each do |rating| %>
      <tr>
        <td><%= rating.title %></td>
        <td><%= rating.review %></td>
        <td><%= rating.rating %></td>
        <td><%= rating.user %></td>
        <td><%= rating.movie %></td>
        <td><%= link_to 'Show', rating %></td>
        <td><%= link_to 'Edit', edit_rating_path(rating) %></td>
        <td><%= link_to 'Destroy', rating, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Rating', new_rating_path %>

app/views/ratings/new.html.erb
<h1>New Rating</h1>

<%= render 'form', rating: @rating %>

<%= link_to 'Back', ratings_path %>

app/views/ratings/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Title:</strong>
  <%= @rating.title %>
</p>

<p>
  <strong>Review:</strong>
  <%= @rating.review %>
</p>

<p>
  <strong>Rating:</strong>
  <%= @rating.rating %>
</p>

<p>
  <strong>User:</strong>
  <%= @rating.user %>
</p>

<p>
  <strong>Movie:</strong>
  <%= @rating.movie %>
</p>

<%= link_to 'Edit', edit_rating_path(@rating) %> |
<%= link_to 'Back', ratings_path %>